# Übungen Software-Entwicklung 3: Build Management & Testing

## Ausgangslage
In der Vorlesung wurde die Container-Technologie (Docker) als auch die Prinzipien von Continuous Integration/Continuous Deployment vorgestellt. Mit Hilfe con GitLab sollen Sie nun diese Prinzipien in Ihrem Projekt anwenden. Voraussetzung dafür ist, dass sie Ihr Projekt mit Hilfe eines Buildmangementtools (z.B. `maven`) per Kommandozeile bauen, testen und paketieren können.

## Aufgabe
* Erstellen Sie eine passende `.gitlab-ci.yml`, sodass sie die Build-Lifecycle Phasen `compile`, `test` und `package` in GitLab ausführen können.
* Überlegen Sie sich welche Phasen des Build-Lifecycle immer ausgeführt werden müssen und welche nur bei bestimmten Ereignissen (z.B. neuer `Tag` erstellt).

## Tipps
* Nutzen Sie als Start die `.gitlab-ci.yml` aus dem [Vorlesungsprojekt](https://gitlab.mi.hdm-stuttgart.de/jordine/se3sose2022projekt)
* Weitere Informationen gibt es in der [GitLab Ci Dokumentation](https://docs.gitlab.com/ee/ci/) bzw. in der [Keyword Reference](https://docs.gitlab.com/ee/ci/yaml/)
* Ggf. kann es sinnvoll sein, Ihre Anwendung oder Teile davon (z.B. Datenbank, Webserver) in einem Container zu kapseln, sodass eine gleichbleibende Ausführungsumgebung sichergestellt ist.

## Ziele
* Ihr Projekt wird über einen CI/CD-Mechanismus regelmäßig gebaut und getestet.