# Projektbeschreibung

_SE3, Sommersemester 2022, Stand 20.03.2022_

## Allgemeines

* Das Projekt soll als Gruppenaufgabe mit 5-7 Mitgliedern gelöst werden. Nach Abgabe werden anhand der GitLab-Commits die Aktivitäten der Teilnehmer überprüft. Das Verwenden von bereits existierendem Code ist erlaubt, sofern Sie dies kennzeichnen und den Code erklären können.
* Die Abgabe des Projekts erfolgt als Link auf das lesbare GitLab-Repository per E-Mail an [jordine@hdm-stuttgart.de](mailto:jordine@hdm-stuttgart.de) und die Tutoren. Anschließend gibt es noch mit jeder Gruppe ein Abgabegespräch.
* Es ist eine Projektdokumentation zu erstellen und abzugeben. Diese soll direkt als Wiki im GitLab-Repository abgelegt werden.
* Abgabetermine:
  * Link: 15.07.2022
  * Projektdokumentation: 15.07.2022 
  * Abgabegespräch: Individuelle Terminvereinbarung 
  * Hinweis: Nach Ende der Vorlesungszeit (01.07.) können wir keinen Support durch die Betreuer mehr
    zusagen. Deshalb: Stellen Sie Ihr Projekt rechtzeitig vorher fertig.
* Beim Abgabegespräch wird Folgendes gefordert:
  * Alle Teammitglieder müssen in der Lage sein, die Architektur der Anwendung zu erklären.
  * Alle Team-Mitglieder müssen in der Lage sein, alle Teile des Projektes grob zu erklären (Was ist die Aufgabe? Wie wurde die Aufgabenstellung prinzipiell umgesetzt? Wie sieht die Struktur aus?)
  * Jedes Teammitglied muss bei einem Teil des Projekts (von angemessenem Umfang) in der Lage sein, detailliert zu erklären, was wie implementiert wurde.
* In der Regel wird das Projekt als Ganzes bewertet. Alle Teammitglieder erhalten die gleiche Note. Falls wir feststellen sollten, dass die Leistungen der einzelnen Teammitglieder deutlich unterschiedlich sind, behalten wir uns aber vor, auch unterschiedliche Noten zu vergeben.
* Es sind zwei Review-Termine geplant:
  * 25.04.: Vorstellung des MVPs
  * 27.06.: Abschlusspräsentation

## Bei der Umsetzung des Projektes müssen folgende Punkte beachtet werden

_Vorläufig! Eine detaillierte Bewertungstabelle wird zeitnah zur Verfügung gestellt._ 

* Sinnvolle Projektorganisation. Dies umfasst:
  * Erfassung der Anforderungen 
  * Definition eines Minimum Viable Projects (MVP)
  * Priorisierung der zusätzlichen Features
  * Zeitmanagement 
  * Benutzung von Gitlab
    * Branching 
    * Issue-Tracking 
    * CI/CD 
    * Abdeckung der wesentlichen Funktionalität durch Unittests 
* Sinnvolle Software-Architektur. Die Architektur muss in der Projektdokumentation beschrieben werden. Sie sollten erklären können:
  * Warum Sie sich für die gewählte Architektur entschieden haben. 
  * An welchen Stellen Verbesserungen sinnvoll wären, die Sie aber aus Aufwandsgründen nicht mehr umgesetzt haben. 
  * An welchen Stellen Sie im Nachhinein festgestellt haben, dass Verbesserungen/Änderungen sinnvoll
    wären.
* Clean Code

## Wahlpflichthemen

Zwei der folgenden Themen müssen im Projekt berücksichtigt werden.

* Parallelisierung
* Datenbankanbindung
* Networking (z.B. REST, GraphQL)
* UI