# Übungen Software-Entwicklung 3: `git`, Dokumentation, Clean Code

## Ausgangslage
In der Vorlesung haben Sie weitergehende Konzepte zu `git`, Dokumentation und Clean Code kennengelernt. Diese sollen nun auf Ihr Projekt angewandt werden.

## Aufgabe
* Überlegen Sie sich im Team, wie Sie mit `git` umgehen möchten. 
  * Wie sieht Ihr Workflow aus?
  * Wie möchten Sie mit Branches umgehen?
  * Wann werden Tags erstellt? Wie ist Ihre Versionsschematik?
* Erstellen Sie in Ihrem Repository ein Changelog, in dem Ihre Änderungen festhalten und pflegen.
* Erstellen Sie eine Readme, die beschreibt, wie Ihr Projekt gestartet wird.
* Legen Sie Ihre Projektdokumentation in einem Wiki ab.
* Prüfen Sie Ihren vorhandenen Code auf die `SOLID`-Prinzipien und passen diesen ggf. entsprechend an.
  * Sind Benennungen so gewählt, dass diese keine weitere Erklärung benötigen?
  * Sind Ihre Klassen immer gleichartig strukturiert?

## Tipps
* Nutzen Sie `git` auf der Commandline. Das hilft, die Konzepte zu verinnerlichen.
* Scheuen Sie sich nicht vor `merge`-Konflikten! Nach ein paar Mal, ist es nicht mehr so schlimm 😊
* Nutzen Sie `merge`-Requests, um sich gegenseitig zu reviewen.
* Schauen Sie in das [Vorlesungsprojekt](https://gitlab.mi.hdm-stuttgart.de/jordine/se3sose2022projekt). Hier finden Sie eine Möglichkeit wie Sie Beispiele wie die `SOLID`-Prinzipien umgesetzt werden können.

## Ziele
* Sie können mit `git` umgehen und haben eine Vorgehensweise für branches definiert.
* Changelogs dokumentieren wesentliche Änderungen Ihres Projekts.
* Eine Readme beschreibt wie Ihr Projekt gestartet werden kann.
* Ihre Dokumentation liegt in einem Wiki ab.
* Die `SOLID`-Prinzipen werden in Ihrem Projekt angewandt.